using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace sample1
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		Hashtable formulas = new Hashtable();
		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			DataTable dt = this.GetTable();
			this.gridDataBoundGrid1.DataSource = this.GetTable();
			this.gridDataBoundGrid1.TableStyle.CellType = "FormulaCell";
			this.gridDataBoundGrid1.TableStyle.CellValueType = typeof(System.Single);


			this.gridDataBoundGrid1.AllowResizeToFit = false;
			this.gridDataBoundGrid1.DefaultColWidth = 70;

			this.gridDataBoundGrid1.Model.QueryCellInfo += new GridQueryCellInfoEventHandler(GridQueryCellInfo);
			this.gridDataBoundGrid1.Model.SaveCellInfo += new GridSaveCellInfoEventHandler(GridSaveCellInfo);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(8, 8);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.OptimizeInsertRemoveCells = true;
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(392, 224);
			this.gridDataBoundGrid1.SmartSizeBox = false;
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 0;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.UseListChangedEvent = true;
			this.gridDataBoundGrid1.CurrentCellValidating += new System.ComponentModel.CancelEventHandler(this.gridDataBoundGrid1_CurrentCellValidating);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(408, 238);
			this.Controls.Add(this.gridDataBoundGrid1);
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		DataTable GetTable()
		{
			DataTable dt = new DataTable();
			for(int i=0;i<5;i++)
			{
				DataColumn col = new DataColumn(GridRangeInfo.GetAlphaLabel(i+1));
				dt.Columns.Add(col);
			}
			for(int i=0;i<10;i++)
			{
				DataRow row = dt.NewRow();
				for(int j=0;j<5;j++)
						row[j] = i*10+j+1;
				dt.Rows.Add(row);
			}
			return dt;

		}

		private int GetKey(int row, int col)
		{
			return (row << 16) | col;
		}

		private void GridSaveCellInfo(object sender, GridSaveCellInfoEventArgs e)
		{
			if(e.ColIndex >0 && e.RowIndex > 0 && e.RowIndex < this.gridDataBoundGrid1.Model.RowCount)
			{
				int key = GetKey(e.RowIndex, e.ColIndex);
				bool isInFormulas = this.formulas.ContainsKey(key);
				
				if(e.Style.FormulaTag != null)
				
					if(isInFormulas)
						this.formulas[key] = e.Style.FormulaTag;
					else
					{
						this.formulas.Add(key, e.Style.FormulaTag);
						Console.WriteLine(e.Style.FormulaTag.Formula);
					}
				
				else if(isInFormulas)
					this.formulas.Remove(key);

				e.Handled = true;
			}
		}

		private void GridQueryCellInfo(object sender, GridQueryCellInfoEventArgs e)
		{
			if(e.ColIndex > 0 && e.RowIndex > 0 && e.RowIndex < this.gridDataBoundGrid1.Model.RowCount)
			{
				int key = GetKey(e.RowIndex, e.ColIndex);
				e.Style.FormulaTag = this.formulas[key] as GridFormulaTag;
				e.Handled = true;
			}
		}

		private void gridDataBoundGrid1_CurrentCellValidating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			GridCurrentCell cc = this.gridDataBoundGrid1.CurrentCell;
			if(cc.RowIndex>0 && cc.ColIndex >0)
			{
				if(cc.Renderer.ControlText.StartsWith("/") || cc.Renderer.ControlText.StartsWith("=/"))
				{
					cc.ErrorMessage = "binary operators cannot start an expression";
					cc.RejectChanges();
					cc.Renderer.ControlText = cc.Renderer.StyleInfo.Text;
					e.Cancel = true;
					
					
				}

			}
		}


	}
}
